/*
 * Copyright (c) 2021-2024, NVIDIA CORPORATION.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * NOTE: this file is generated by registers_00_generate.py
 *
 * Make changes there and run in this directory:
 *
 * > python registers_00_generate.py
 *
 */

#include <raft/spatial/knn/detail/ball_cover/registers-inl.cuh>

#include <cstdint>  // int64_t

#define instantiate_raft_spatial_knn_detail_rbc_eps_pass(                                  \
  Mvalue_idx, Mvalue_t, Mvalue_int, Mmatrix_idx, Mdist_func)                               \
  template void                                                                            \
  raft::spatial::knn::detail::rbc_eps_pass<Mvalue_idx, Mvalue_t, Mvalue_int, Mmatrix_idx>( \
    raft::resources const& handle,                                                         \
    const BallCoverIndex<Mvalue_idx, Mvalue_t, Mvalue_int, Mmatrix_idx>& index,            \
    const Mvalue_t* query,                                                                 \
    const Mvalue_int n_query_rows,                                                         \
    Mvalue_t eps,                                                                          \
    const Mvalue_t* R_dists,                                                               \
    Mdist_func<Mvalue_t, Mvalue_int>& dfunc,                                               \
    bool* adj,                                                                             \
    Mvalue_idx* vd);                                                                       \
                                                                                           \
  template void                                                                            \
  raft::spatial::knn::detail::rbc_eps_pass<Mvalue_idx, Mvalue_t, Mvalue_int, Mmatrix_idx>( \
    raft::resources const& handle,                                                         \
    const BallCoverIndex<Mvalue_idx, Mvalue_t, Mvalue_int, Mmatrix_idx>& index,            \
    const Mvalue_t* query,                                                                 \
    const Mvalue_int n_query_rows,                                                         \
    Mvalue_t eps,                                                                          \
    Mvalue_int* max_k,                                                                     \
    const Mvalue_t* R_dists,                                                               \
    Mdist_func<Mvalue_t, Mvalue_int>& dfunc,                                               \
    Mvalue_idx* adj_ia,                                                                    \
    Mvalue_idx* adj_ja,                                                                    \
    Mvalue_idx* vd)

instantiate_raft_spatial_knn_detail_rbc_eps_pass(
  std::int64_t, float, std::int64_t, std::int64_t, raft::spatial::knn::detail::EuclideanSqFunc);
#undef instantiate_raft_spatial_knn_detail_rbc_eps_pass
